xfs/{263,106}: erase max warnings printout
[xfstests-dev.git] / tests / ext4 / 007
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 007
6 #
7 # Create and populate an ext4 filesystem, corrupt the primary superblock, then
8 # see how the kernel and e2fsck deal with it.
9 #
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17 trap "_cleanup; exit \$status" 0 1 2 3 15
18
19 _cleanup()
20 {
21     cd /
22     #rm -f $tmp.*
23 }
24
25 # get standard environment, filters and checks
26 . ./common/rc
27 . ./common/filter
28 . ./common/attr
29
30 # real QA test starts here
31 _supported_fs ext4
32 _supported_os Linux
33
34 _require_scratch
35 test -n "${FORCE_FUZZ}" || _require_scratch_ext4_crc
36 _require_attrs
37
38 rm -f $seqres.full
39 TESTDIR="${SCRATCH_MNT}/scratchdir"
40 TESTFILE="${TESTDIR}/testfile"
41
42 echo "+ create scratch fs"
43 _scratch_mkfs_ext4 > /dev/null 2>&1
44 dumpe2fs -g "${SCRATCH_DEV}" > /dev/null 2>&1 || _notrun "dumpe2fs -g not supported"
45
46 echo "+ mount fs image"
47 _scratch_mount
48 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
49 nr_groups="$(dumpe2fs -g "${SCRATCH_DEV}" 2> /dev/null | tail -n 1 | cut -d : -f 1)"
50 test "${nr_groups}" -gt 0 || _notrun "scratch device not big enough for backup superblocks"
51 backup_sb="$(dumpe2fs -g "${SCRATCH_DEV}" 2> /dev/null | awk -F ':' 'BEGIN {x = 0;} {if (x == 0 && int($3) > 1) {print $3; x++;}}')"
52
53 echo "+ make some files"
54 mkdir -p "${TESTDIR}"
55 for x in `seq 1 128`; do
56         touch "${SCRATCH_MNT}/junk.${x}"
57         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
58         if [ "$x" -gt 64 ] && [ "$((inode % 64))" -eq 0 ]; then
59                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
60                 break
61         fi
62 done
63 for x in `seq 2 64`; do
64         touch "${TESTFILE}.${x}"
65 done
66 umount "${SCRATCH_MNT}"
67
68 echo "+ check fs"
69 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
70
71 echo "+ corrupt image"
72 dumpe2fs -g "${SCRATCH_DEV}" 2>/dev/null | awk -F ':' '{if ($1 == 0) {print $3}}' | while read blk; do
73         debugfs -w -R "zap_block ${blk}" "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "primary sb fuzz failed"
74 done
75
76 echo "+ mount image"
77 _try_scratch_mount 2> /dev/null && _fail "mount should not succeed"
78
79 echo "+ repair fs"
80 # Have to specify backup sb and blocksize here so we don't pick up superblocks
81 # scattered elsewhere on the scratch device.
82 echo e2fsck -f -y -B "${blksz}" -b "${backup_sb}" "${SCRATCH_DEV}" >> $seqres.full 2>&1
83 e2fsck -f -y -B "${blksz}" -b "${backup_sb}" "${SCRATCH_DEV}" >> $seqres.full 2>&1
84
85 echo "+ mount image (2)"
86 _scratch_mount
87
88 echo "+ chattr -R -i"
89 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
90
91 echo "+ modify files (2)"
92 broken=0
93 for x in `seq 1 64`; do
94         test -e "${TESTFILE}.${x}" || continue
95         stat "${TESTFILE}.${x}" >> /dev/null 2>&1
96         test $? -ne 0 && broken=1
97         echo moo | dd oflag=append of="${TESTFILE}.${x}" 2>/dev/null
98         test $? -ne 0 && broken=1
99 done
100 echo "broken: ${broken}"
101 umount "${SCRATCH_MNT}"
102
103 echo "+ check fs (2)"
104 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
105
106 status=0
107 exit